/**
 *    author:  [itmo] enot.1.10
 *    created: 11.02.2017 10:49:33       
**/
#define __USE_MINGW_ANSI_STDIO 0
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;

/* --- main part --- */

const int N = 1e5 + 10;

int a[N];

int main()
{
    assert(freopen("gotham.in", "r", stdin));
    assert(freopen("gotham.out", "w", stdout));
    int n, m;
    scanf("%d%d", &n, &m);
    forn(i, n) scanf("%d", &a[i]);
    if (m > 0 && n == 1) return 0 * printf("-1\n");
    sort(a, a + n);
    reverse(a, a + n);
    int s = 0;
    forn(i, n) s += a[i];
    if (s / 2 < m) return 0 * printf("-1\n");
    int res = 1;
    forn(i, n) if (a[i] >= i && i * (i + 1) / 2 <= m) res = i + 1;
    printf("%d\n", res);
    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
