#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <utility>

using namespace std;

const int N = 100500;

int n, m;
int deg[N];
pair<int, int> b[N];
long long all_deg_sum = 0LL;

bool can(int size) {
	if (b[n - size + 1].first >= size - 1) {
		int index = n - size + 1;
		for (int i = 1; i < index; i++) {
			deg[i] = b[i].first;
		}
		for (int i = index; i <= n; i++) {
			deg[i] = b[i].first - (size - 1);
		}
		int rem = m - (size * (size - 1)) / 2;
		int cur_dec = 0;
		int delayed = 0;
		for (int i = 1; i <= n; i++) {
			int dec_now = min(delayed, deg[i]);
			delayed -= dec_now;
			cur_dec += dec_now;
			if (cur_dec >= rem) {
			    break;
			}
			deg[i] -= dec_now;
			delayed += deg[i];
			delayed = min(delayed, 100500);
		}
		return (cur_dec >= rem);
	} else {
		return false;
	}
}

int main() {
	freopen("gotham.in","r",stdin);
	freopen("gotham.out","w",stdout);
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; i++) {
		scanf("%d", &deg[i]);
		b[i] = make_pair(deg[i], i);
		all_deg_sum += (1LL * deg[i]);
	}
	sort(b + 1, b + 1 + n);
	int last_possible = -1;
	for (int size = 1; size <= n; size++) {
		int need_edges = (size * (size - 1)) / 2;
		if (need_edges > m) {
			break;
		}
		if (can(size)) {
			last_possible = size;
		}
	}
	printf("%d\n", last_possible);
	return 0;
}