#define _ijps 0
#define _CRT_SECURE_NO_DEPRECATE
//#pragma comment(linker, "/STACK:667772160")
#include <iostream>
#include <cmath>
#include <vector>
#include <time.h>
#include <map>
#include <set>
#include <deque>
#include <cstdio>
#include <cstdlib>
#include <unordered_map>
#include <bitset>
#include <algorithm>
#include <string>
#include <fstream>
#include <assert.h> 
#include <list>
#include <cstring>
#include <queue>
using namespace std;

#define name "paths"
typedef unsigned long long ull;
typedef long long ll;
#define mk make_pair
#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define fornn(i, q, n) for(ll i = (ll)q; i < (ll)n; i++)
#define times clock() * 1.0 / CLOCKS_PER_SEC


struct __isoff{
	__isoff(){
		if (_ijps)
			freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);//, freopen("test.txt", "w", stderr);
		else freopen(name".in", "r", stdin), freopen(name".out", "w", stdout);
		//ios_base::sync_with_stdio(0);
		//srand(time(0));
		srand('C' + 'T' + 'A' + 'C' + 'Y' + 'M' + 'B' + 'A');
	}
	~__isoff(){
		//if(_ijps) cout<<times<<'\n';
	}
} __osafwf;
const ull p1 = 131;
const ull p2 = 129;
const double eps = 1e-8;
const double pi = acos(-1.0);

const int infi = 1e9 + 7;
const ll inf = 1e18 + 7;
const ll dd = 2e5 + 7;

vector<int> P[dd];
int n, m;
int res = 0;

int H[dd], L[dd], R[dd], dp[dd];
const int logn = 19;
int up[dd][logn];
int Re = 0;

int is(int a, int b){
	return L[a] <= L[b] && R[b] <= R[a];
}

void dfs(int v, int p, int h){
	static int time = 0;
	L[v] = time++;
	H[v] = h;
	up[v][0] = p;
	for(int i = 1; i < logn; i++){
		up[v][i] = up[up[v][i - 1]][i - 1];
	}
	for(auto u : P[v]){
		if(u != p){
			dfs(u, v, h + 1);
		}
	}
	R[v] = time++;
}

int getUp(int a, int b){
	for(int i = logn - 1; i >= 0; i--){
		int c = up[b][i];
		if(H[a] < H[c]){
			b = c;
		}
	}
	return b;
}

void dps(int v, int p, int s){
	s += dp[v];
	res = max(res, s);
	for(auto u : P[v]){
		if(u != p){
			dps(u, v, s);
		}
	}
}

int main() {
	cin >> n;
	for(int i = 0; i < n - 1; i++){
		int a, b;
		scanf("%d%d", &a, &b);
		a--, b--;
		P[a].push_back(b);
		P[b].push_back(a);
	}
	dfs(0, 0, 0);
	cin >> m;
	for(int i = 0; i < m; i++){
		int a, b;
		scanf("%d%d", &a, &b);
		a--, b--;
		if(is(b, a)){
			swap(a, b);
		}
		if(is(a, b)){
			Re++;
			int c = getUp(a, b);
			dp[c]--;
			dp[b]++;
		}
		else{
			dp[a]++;
			dp[b]++;
		}
	}
	dps(0, 0, 0);
	cout << res + Re << '\n';
}