/**
 *    author:  [itmo] enot.1.10
 *    created: 10.02.2017 23:07:11       
**/
#define __USE_MINGW_ANSI_STDIO 0
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;

/* --- main part --- */

const int N = 2e5 + 10;
const int LOG = 20;


vi v[N];
int up[N][LOG];
int in[N], out[N], T = 0;

void dfs(int x, int pr)
{
    up[x][0] = pr;
    for (int i = 1; i < LOG; ++i) up[x][i] = up[up[x][i - 1]][i - 1];
    in[x] = T++;

    for (int y : v[x])
    {
        if (y != pr) dfs(y, x);
    }

    out[x] = T;
}

int s[N];

void add(int l, int r, int dv)
{
    s[l] += dv;
    s[r] -= dv;
}

int main()
{
    assert(freopen("paths.in", "r", stdin));
    assert(freopen("paths.out", "w", stdout));
    int n;
    scanf("%d", &n);
    forn(i, n - 1)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        --x, --y;
        v[x].pb(y);
        v[y].pb(x);
    }
    dfs(0, 0);
    int m;
    scanf("%d", &m);
    forn(_, m)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        --x, --y;

        if (in[x] <= in[y] && out[y] <= out[x])
        {
            add(in[y], out[y], 1);
            for (int i = LOG - 1; i >= 0; --i)
            {
                int z = up[y][i];
                if (!(in[z] <= in[x] && out[x] <= out[z])) y = z;
            }
            add(0, n, 1);
            add(in[y], out[y], -1);
        }
        else if (in[y] <= in[x] && out[x] <= out[y])
        {
            add(in[x], out[x], 1);
            for (int i = LOG - 1; i >= 0; --i)
            {
                int z = up[x][i];
                if (!(in[z] <= in[y] && out[y] <= out[z])) x = z;
            }
            add(0, n, 1);
            add(in[x], out[x], -1);
        }
        else
        {
            add(in[x], out[x], 1);
            add(in[y], out[y], 1);
        }
    }

    int mx = -1;

    int ss = 0;
    forn(i, n)
    {
        ss += s[i];
        mx = max(mx, ss);
    }
    printf("%d\n", mx);







            
    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
